/**************************
** TDDD56 Lab 3
***************************
** Author:
** August Ernstsson
**************************/

#include <stdio.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <time.h>
#include <iterator>

#include <skepu>

#include "support.h"


unsigned char median_kernel(skepu::Region2D<unsigned char> image, size_t elemPerPx)
{
	//const int SIZE = ((50*2)+1)*((50*2)+1);
	unsigned char imageArray[10201];
	unsigned char temp;

	int k = 0;

	for(int i = -image.oi; i <= image.oi; i++)
	{
		for(int j = -image.oj; j <= image.oj; j += elemPerPx)
		{
			imageArray[k] = image(i, j);
			k++;
		}
	}
//Bubblesort
	for (int i = 0; i < k-1; i++){
		for (int j = 0; j < k-i-1; j++) {
			if (imageArray[j] > imageArray[j+1]) {
				 temp = imageArray[j];
				 imageArray[j] = imageArray[j+1];
				 imageArray[j+1] = temp;

			}
		}
	}

	int median = (k-1)/2;

	return imageArray[median];
}
/*
unsigned char median_kernel_vector(skepu::Region2D<unsigned char> image, skepu::Vector<unsigned char> sortingVec, size_t elemPerPx)
{
	int row_size = image.oi*2+1;
	int col_size = image.oj*2+1;
	int n = row_size*col_size;
	int i, j, x, y, x_next, y_next;
	int k = 0;
	unsigned char temp;
	for(i = -image.oj; i <= image.oi; i++)
		for(j = -image.oj; j <= image.oj; j++)
			sortingVec(k) = image(i,j);


	for (i = 0; i < n-1; i++){
		// Last i elements are already in place
		for (j = 0; j < n-i-1; j += elemPerPx) {
			if (sortingVec(j) > sortingVec(j+1)) {
				temp = sortingVec(j);
		    sortingVec(j) = sortingVec(j+1);
		    sortingVec(j+1) = temp;

			}
		}
	}

	return image(0,0);
}


*/
int main(int argc, char* argv[])
{
	LodePNGColorType colorType = LCT_RGB;

	if (argc < 5)
	{
		std::cout << "Usage: " << argv[0] << " input output radius [backend]\n";
		exit(1);
	}

	std::string inputFileName = argv[1];
	std::string outputFileName = argv[2];
	const int radius = atoi(argv[3]);
	auto spec = skepu::BackendSpec{argv[4]};
	skepu::setGlobalBackendSpec(spec);

	// Create the full path for writing the image.
	std::stringstream ss;
	ss << (2 * radius + 1) << "x" << (2 * radius + 1);
	std::string outputFileNamePad = outputFileName + ss.str() + "-median.png";

	// Read the padded image into a matrix. Create the output matrix without padding.
	ImageInfo imageInfo;
	skepu::Matrix<unsigned char> inputMatrix = ReadAndPadPngFileToMatrix(inputFileName, radius, colorType, imageInfo);
	std::cout << imageInfo.height << ", " << imageInfo.width << std::endl;
	std::cout << inputMatrix.total_cols() << ", " << inputMatrix.total_rows() << std::endl;
	skepu::Matrix<unsigned char> outputMatrix(imageInfo.height, imageInfo.width * imageInfo.elementsPerPixel, 120);

	std::cout << outputMatrix.total_cols() << ", " << outputMatrix.total_rows() << std::endl;

	// Skeleton instance
	auto calculateMedian = skepu::MapOverlap(median_kernel);
	calculateMedian.setOverlap(radius, radius  * imageInfo.elementsPerPixel);
	skepu::Vector<unsigned char> sortingVec((radius*2+1)*(radius*2+1)*imageInfo.elementsPerPixel);

	auto timeTaken = skepu::benchmark::measureExecTime([&]
	{
		calculateMedian(outputMatrix, inputMatrix, imageInfo.elementsPerPixel);
	});

	WritePngFileMatrix(outputMatrix, outputFileNamePad, colorType, imageInfo);

	std::cout << "Time: " << (timeTaken.count() / 10E6) << "\n";

	return 0;
}
