// Matrix addition, CPU version
// gcc matrix_cpu.c -o matrix_cpu -std=c99

#include <stdio.h>
#include <stdlib.h>
#include "milli.h"

void add_matrix(float *a, float *b, float *c, int N)
{
	int index;

	for (int i = 0; i < N; i++)
		for (int j = 0; j < N; j++)
		{
			index = i + j*N;
			c[index] = a[index] + b[index];
		}
}

int main(int argc, char *argv[])
{
	char *argument = argv[argc-1];
  int N = atoi(argument);
  printf("Running on CPU with no of elements: %i \n",N);

	float *a = malloc(N*N*sizeof(float));
	float *b = malloc(N*N*sizeof(float));
	float *c = malloc(N*N*sizeof(float));

	for (int i = 0; i < N; i++)
		for (int j = 0; j < N; j++)
		{
			a[i+j*N] = 10 + i;
			b[i+j*N] = (float)j / N;
		}
	ResetMilli();
	add_matrix(a, b, c, N);
	printf("%s%f\n","Measured time (ms): ", (float)GetMicroseconds()*0.001);
/*
	for (int i = 0; i < N; i++)
	{
		for (int j = 0; j < N; j++)
		{
			printf("%0.2f ", c[i+j*N]);
		}
		printf("\n");
	}
	*/
	free(a);
	free(b);
	free(c);
}
